; ShortCut v0.7
; (C) 2003-2004 Andy Janata.
;
;	This program is free software; you can redistribute it and/or modify
;	it under the terms of the GNU General Public License as published by
;	the Free Software Foundation; either version 2 of the License, or
;	(at your option) any later version.
;
;	This program is distributed in the hope that it will be useful,
;	but WITHOUT ANY WARRANTY; without even the implied warranty of
;	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;	GNU General Public License for more details.
;
;	You should have received a copy of the GNU General Public License
;	along with this program; if not, write to the Free Software
;	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

; I hope to make it easily customizeable later (i.e., either edit an include file by
;   hand or use a Windows program to do so, then recompile, sign, etc.). It would
;   have to be done on a computer and rebuilding the app since the information would
;   be pretty big and unreasonable for an AppVar.


RawkeyHook:
    db 83h
    set keybReportAll,(iy+keybFlags)    ; We turn this back on on every keypress since
                                        ; NoteFolio is naughty and turns it off every time
                                        ; it quits.
; di
; halt
    ld (saveAccumulator),a      ; trashed with keyExtend
    call rkhChkSpecial          ; check for APD, Contrast, and Accent keys
    ld b,keyNumMappings
    ld hl,keyMappings
rkhLoop:
    cp (hl)                     ; check the value of a
    jr nz,rkhAccNoMatch
    ld a,(keyExtend)
    inc hl
    cp (hl)
    jr z,rkhDoReplace
    jr rkhExtendNoMatch
rkhAccNoMatch:
    inc hl
    jr rkhAccNoMatch2
rkhExtendNoMatch:
    ld a,(saveAccumulator)
rkhAccNoMatch2:
    inc hl
    inc hl
    inc hl
    djnz rkhLoop
rkhNormalQuit:
    ld a,(saveAccumulator)      ; if we get here then there is nothing to do

rkhQuitAfterReplace:
    ld (saveAccumulator),a          ; we need to mess with a a bit more
    call LoadAppVar_RKH
    ex de,hl
    bit 1,(hl)
    jr z,rkhQuitAfterReplace_NoChain
  ;di
  ;halt
    inc hl
    ld a,(hl)
    inc hl
    ld e,(hl)
    inc hl
    ld d,(hl)
    ex de,hl
    ld b,a
    B_CALL LoadCIndPaged        ; check that what we think we are chaining to is indeed a valid hook
    ld a,83h
    cp c
    jp nz,rkhQuitAfterReplace_NoChain
    ld a,b
    inc hl              ; skip over the sanity instruction
    jp doRomJump


rkhQuitAfterReplace_NoChain:
    ld a,(saveAccumulator)
    or a            ; make sure z is reset
            ; this is where we want to see if we need to chain to another App
            ; if we do, then we want this psuedo-code to be run:
            ;  ld (saveAccumulator),a
            ;  ld a,[page]
            ;  ld hl,[address]
            ;  jp doRomJump
    ret

rkhDoReplace:           ; this should still work since the other inc hl is above
    inc hl              ; (hl) = new acc
    ld a,(hl)
    inc hl              ; (hl) = new (keyExtend)
    ld b,(hl)           ; now to load keyExtend the roundabout way...
    ld hl,keyExtend
    ld (hl),b
    jr rkhQuitAfterReplace

;;;;;;;;; SPECIAL KEYS THAT MUST BE HANDLED BY US

rkhChkSpecial:
    ; note - if we want to ret from the keyhook here, pop an extra word off the stack
    ;   since we made a call here
    ; stack: <caller> <hookcaller>
    ; acc is saved in (saveAccumulator)
    ld c,a    
    ld a,(keyExtend)
    ld b,a
;    ld a,(saveAccumulator)
    ld a,keyForAPD_Acc
    cp c
    jr nz,specNotAPD
    ld a,keyForAPD_Extend
    cp b
    jr z,specAPD
specNotAPD:
    ld a,keyForContrUp_Acc
    cp c
    jr nz,specNotContrUp
    ld a,keyForContrUp_Extend
    cp b
    jr z,specContrUp
specNotContrUp:
    ld a,keyForContrDn_Acc
    cp c
    jr nz,specNotContrDn
    ld a,keyForContrDn_Extend
    cp b
    jr z,specContrDn
specNotContrDn:
    ld a,keyForLAccent_Acc
    cp c
    jr nz,specNotLAccent
    ld a,keyForLAccent_Extend
    cp b
    jr z,specLAccent
specNotLAccent:
    ld a,keyForCAccent_Acc
    cp c
    jr nz,specNotCAccent
    ld a,keyForCAccent_Extend
    cp b
    jp z,specCAccent
specNotCAccent:    
        ; return to the main keyhook
    ld a,c
    ret

specQuitHook:       ; if we want it to ignore the key!
    xor a           ; don't process the key please
specQuitHookNoXor:  ; if we want it to process the key!
    pop bc          ; the address rkhChkSpecial was called from
    ret             ; this quits the keyhook



specAPD:
	ld a,3
	out (0),a
	;ld b,32
	;call wait_b
	b_call PowerOff
    jr specQuitHook

specContrUp:
    
    jp contrastFucked

    ld a,(contrast)
    ; add $18 to (contrast) for lcd, increment by 1
;    inc a
;    ld (contrast),a
    cp 3Fh
    jr c,specQuitHook
    add 19h
;    cp 3Fh
;    jr c,specContrUp2
;    sub 19h
    ld (contrast),a
;    jr specQuitHook
specContrUp2:
    or 0C0h
    out (10h),a
    jr specQuitHook

specContrDn:

    jp contrastFucked

    ld a,(contrast)
    ; add $18 to (contrast) for lcd, decrement by 1
;    dec a
;    ld (contrast),a
    or a
    jr z,specQuitHook
    add 17h
;    cp 18h
;    jr nc,specContrDn2
;    sub 17h
    ld (contrast),a
;    jr specQuitHook
specContrDn2:
    ld (contrast),a
    or 0C0h
    out (10h),a
    jr specQuitHook

specLAccent:
    set indicRun,(iy+indicFlags)        ; turn run indicator on
    b_call GetKey                       ; calling GetKey from the Rawkey hook is safe, I hope...
    res indicRun,(iy+indicFlags)        ; turn run idicator off
    cp kCapA
    jr nz,specLA_notA
    ld a,kaAcute
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specLA_notA:
    cp kCapE
    jr nz,specLA_notE
    ld a,keAcute
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specLA_notE:
    cp kCapI
    jr nz,specLA_notI
    ld a,kiAcute
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specLA_notI:
    cp kCapO
    jr nz,specLA_notO
    ld a,koAcute
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specLA_notO:
    cp kCapU
    jr nz,specLA_notU
    ld a,kuAcute
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specLA_notU:
    cp kCapN
    jr nz,specLA_notN
    ld a,knTilde
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specLA_notN:
    cp kQuest
    jr nz,specLA_notQuest
    ld a,kquesDown
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specLA_notQuest:
    cp kExtendEcho                      ; note: kExclam is a 2-byte kExtendEcho
    jr nz,specLA_notExclam
    ld a,(keyExtend)
    cp kExclam
    jr nz,specLA_notExclam
    ld a,kexclamDown
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specLA_notExclam:
        ; alternate way of getting inverted ! - press the 1 key
    cp k1
    jr nz,specLA_notExclam_1
    ld a,kexclamDown
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
            ; if we get here then the key isn't valid so return no key press
specLA_notExclam_1:
    jp specQuitHook         ; this does all we need it to do


specCAccent:
    set indicRun,(iy+indicFlags)        ; turn run indicator on
    b_call GetKey                       ; calling GetKey from the Rawkey hook is safe, I hope...
    res indicRun,(iy+indicFlags)        ; turn run idicator off
    cp kCapA
    jr nz,specCA_notA
    ld a,kcapAAcute
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specCA_notA:
    cp kCapE
    jr nz,specCA_notE
    ld a,kcapEAcute
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specCA_notE:
    cp kCapI
    jr nz,specCA_notI
    ld a,kcapIAcute
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specCA_notI:
    cp kCapO
    jr nz,specCA_notO
    ld a,kcapOAcute
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specCA_notO:
    cp kCapU
    jr nz,specCA_notU
    ld a,kcapUAcute
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specCA_notU:
    cp kCapN
    jr nz,specCA_notN
    ld a,kcapNTilde
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specCA_notN:
    cp kQuest
    jr nz,specCA_notQuest
    ld a,kquesDown
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specCA_notQuest:
    cp kExtendEcho                          ; kExclam is a 2-byte kExtendEcho
    jr nz,specCA_notExclam
    ld a,(keyExtend)
    cp kExclam
    jr nz,specCA_notExclam
    ld a,kexclamDown
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
specCA_notExclam:
        ; alternate way of getting inverted ! - press the 1 key
    cp k1
    jr nz,specCA_notExclam_1
    ld a,kexclamDown
    ld (keyExtend),a
    ld a,kExtendEcho2
    jp specQuitHookNoXor
            ; if we get here then the key isn't valid so return no key press
specCA_notExclam_1:
    jp specQuitHook         ; this does all we need it to do


contrastFucked:
    call ClrScrn
    InvOn
    Echo fuckedMessage
    InvOff
    b_call GetKey
    call ClrScrn
    jp specQuitHook


fuckedMessage:
;       1234567890ABCDEF
    db "Sorry, but the  "
    db "contrast doesn't"
    db "get set right.  "
    db 0D6h
    db "Press any key..."
    db 0
